clear all;
close all;

scale = 0.5;
left_img = double(imresize(imread('../data/kitti/left/000000.png'),scale));
right_img = double(imresize(imread('../data/kitti/right/000000.png'), scale));
K = load('../data/kitti/K.txt');

% downscale intrinsics
K(1,1) = K(1,1)*scale;
K(2,2) = K(2,2)*scale;
K(1,3) = (K(1,3)+0.5)*scale-0.5;
K(2,3) = (K(2,3)+0.5)*scale-0.5;

% according to kitti dataset
baseline = 0.54;

patch_size = 3;
min_disp = 4;
max_disp = 80;
xlims = [7 20];
ylims = [-6 10];
zlims = [-5 5];

%%%%%%%%%%%%%%%% It's slow!!! %%%%%%%%%%%%%%%%
% compute disparity on the image pair
tic;
disp_img = calcDisparity(left_img, right_img, patch_size, floor(min_disp*scale), ceil(max_disp*scale));
toc
figure;
imagesc(disp_img);
axis equal;
axis off;


% visualize 3D point cloud
[points, intensities] = disparity2PointCloud(...
    disp_img, K, baseline, left_img);

% transform pc from camera frame to world frame
points = [0 -1 0; 0 0 -1; 1 0 0]^-1 * points(:, 1:10:end);

figure;
scatter3(points(1, :), points(2, :), points(3, :), ...
    20 * ones(1, length(points)), ...
    repmat(single(intensities(1:10:end))'/255, [1 3]), 'filled');
axis equal;
axis([0 30 ylims zlims]);
axis vis3d;
grid off;
xlabel('X');
ylabel('Y');
zlabel('Z');



% process entire sequence
scale = 0.125;
figure;
for i = 0:99
    l = double(imresize(imread(sprintf('../data/kitti/left/%06d.png',i)),scale));
    r = double(imresize(imread(sprintf('../data/kitti/right/%06d.png',i)), scale));
    disp_img_i = calcDisparity(l, r, patch_size, floor(min_disp*scale), ceil(max_disp*scale));
    imagesc(disp_img_i);
    axis equal;
    axis off;
    pause(0.01);
end

